#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>


Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver( 0x40 );
// Suivant le type de servo utilisé, la largeur d'impulsion minimale et Maximale 
// peut changer. L'idéal est de sélectionner des valeurs aussi petites et aussi
// grande que possible sans jamais atteindre la butée de blocage du servo-moteur. 
// Vous aurrez peut-etre besoin de modifier ces valeurs pour les faire correspondrent 
// à votre type de servo!


#define NUM_OF_DEVICE 8
int temporary;

byte PWMbyte[NUM_OF_DEVICE];

int pulseLen[NUM_OF_DEVICE] = {0,0,0,0,0,0,0,0};
int SERVO_MIN[NUM_OF_DEVICE]={100,100,100,100,100,100,100,100};
int SERVO_MAX[NUM_OF_DEVICE] ={1200,1200,1200,1200,1200,1200,1200,1200};


int PrevLEDValue[NUM_OF_DEVICE]={0,0,0,0,0,0,0,0};
int convpwm[NUM_OF_DEVICE] ={0,0,0,0,0,0,0,0};

//int nserv=0;
void setup() {

  // if you want to really speed stuff up, you can go into 'fast 400khz I2C' mode
  // some i2c devices dont like this so much so if you're sharing the bus, watch
  // out for this!

  pwm.begin();
  pwm.setPWMFreq(120);

    // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);
  Serial.begin(9600);

}

void loop() {

while(Serial.available()){

  byte inByte = Serial.read();

  if((inByte >= '0') && (inByte <= '9'))

  temporary = 10 * temporary + inByte - '0';

  else if((inByte >= 'a') && (inByte <= 'i')){

    // check whether we're exceeding array size

    if(inByte - 'a' >= NUM_OF_DEVICE) break;

// if we're fine, write byte to corresponding array element

PWMbyte[inByte - 'a'] = temporary;

temporary = 0;

}

// write to servo pins with a for loop

for(int i = 0; i < NUM_OF_DEVICE; i++)

convpwm[i] = PWMbyte[i];

}



    for (uint8_t ch=0; ch < NUM_OF_DEVICE; ch++) {
     if(PrevLEDValue[ch]!=convpwm[ch]){//Change the LED value only if it changed
    

              //MOTEURS
              pulseLen[ch] = map( convpwm[ch], 0, 255, SERVO_MIN[ch], SERVO_MAX[ch] );
              pulseLen[ch] = constrain(pulseLen[ch], SERVO_MIN[ch], SERVO_MAX[ch]);
              pwm.setPWM(ch+8, 20, pulseLen[ch]); 
              //USB
              convpwm[ch] = (4096/255)* convpwm[ch]     ;
              pwm.setPWM(ch, 0, convpwm[ch] );
              
  PrevLEDValue[ch]=convpwm[ch];
  }    
              }
      }



  
